//  uncrustifyGUI.cpp

#ifndef STRICT
#define STRICT
#endif

#define _CRT_SECURE_DEPRECATE_MEMORY
#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include <stdio.h>
#include <shlwapi.h>
#pragma comment(lib,"shlwapi.lib")
#pragma comment(lib, "Comctl32.Lib")
#pragma comment(lib, "User32.Lib")
#pragma comment(lib, "Gdi32.Lib")
#pragma comment(lib, "ComDlg32.Lib")

#define _S(str) str, _ARRAYSIZE(str)
#define _RECT(rc) rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top

HWND hEdit;
extern HWND hEdit;
extern int main(int, char *argv[]);

BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM dwThreadId)
{
	if (GetWindowThreadProcessId(hWnd, NULL) == dwThreadId){
		SetForegroundWindow(hWnd);
		return false;
	}

	return true;
}
LONG_PTR CALLBACK stHookProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg){
		case WM_COMMAND:
			PostMessage(GetParent(GetParent(hWnd)), WM_SYSCOMMAND, wParam, lParam);
			break;
	}

	return CallWindowProc((WNDPROC)GetWindowLong(hWnd, GWL_USERDATA), hWnd, uMsg, wParam, lParam);
}
long CALLBACK  WindProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static char param[5][MAX_PATH] = {"uncrustify.exe", "-c", "uncrustify.cfg", "-f", ""};
	static char *argv[5] = {param[0], param[1], param[2], param[3], param[4]};
	static struct {int id; char str[32]; } menu[] = {
		{psh1, "\[XJ"},
		{psh2, "\[Xۑ"},
		{psh3, "uncrustify.cfg ҏW"},
		{psh4, "uncrustifyGUIɂ"}
	};
	static HWND hStatus;
	static int status_h = 0;
	static HFONT hEditFont;
	static LOGFONT logfont = {12, 0, 0, 0, 0, 0, 0, 0, SHIFTJIS_CHARSET, 0, 0, 0, 0, "lr SVbN"};
	static MENUITEMINFO mii = {sizeof(MENUITEMINFO), MIIM_ID | MIIM_STRING, 0, };
	static char szFile[MAX_PATH];
	static OPENFILENAME ofn = {sizeof(OPENFILENAME), 0, 0, "cpp file(*.cpp)\0*.cpp\0h file(*.h)\0*.h\0all file(*.*)\0*.*\0\0", 0, 0, 0, szFile, sizeof(szFile), 0, 0, 0, 0, 0, 0, 0, "cpp"};
	static STARTUPINFO si = {sizeof(STARTUPINFO), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, STARTF_USESHOWWINDOW, SW_SHOWNORMAL, };
	static PROCESS_INFORMATION pi = {0};
	static MSGBOXPARAMS mbp = {sizeof(MSGBOXPARAMS), 0, 0, "\[X`c[\nuncrustify0.60gpĂ܂\ncppp\nVer 2.1.2013.0816\n(c) S.Hayakawa", menu[3].str, MB_OK, 0, 0, 0, LANG_JAPANESE};
	static int btnSize = 23;
	static int iRight[4] = {btnSize * 4 + 9 * 2 + 2 + 2, 0, 0, -1};
	static TBBUTTON tbtn[6] = {
		{STD_FILEOPEN, psh1, TBSTATE_ENABLED, },
		{STD_FILESAVE, psh2, TBSTATE_ENABLED, },
		{0, 0, 0, TBSTYLE_SEP, },
		{STD_FILENEW, psh3, TBSTATE_ENABLED, },
		{0, 0, 0, TBSTYLE_SEP, },
		{STD_PROPERTIES, psh4, TBSTATE_ENABLED, },
	};
	static TBADDBITMAP tbmp = {HINST_COMMCTRL};
	static TOOLINFO ToolInfo = {sizeof(TOOLINFO), TTF_SUBCLASS};
	static int iTab = 16;
	HMENU hSysMenu;
	FILE *fp;
	char *lpbuffer;
	DWORD dwSize;
	RECT rc;
	HWND hToolTips;
	HWND hStatic;
	HWND hTool;

	switch (uMsg){
		case WM_CREATE:
			ofn.hwndOwner = hWnd;
			ofn.hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);

			GetWindowModuleFileName(hWnd, _S(param[2]));
			PathRemoveFileSpec(param[2]);
			PathAppend(param[2], "uncrustify.cfg");

			hSysMenu = GetSystemMenu(hWnd, false);
			for (int i = 0; i < 4; i++){
				mii.wID        = menu[i].id;
				mii.dwTypeData = menu[i].str;
				InsertMenuItem(hSysMenu, i, true, &mii);
			}
			InsertMenu(hSysMenu, 2, MF_SEPARATOR | MF_BYPOSITION, 0, 0);
			InsertMenu(hSysMenu, 4, MF_SEPARATOR | MF_BYPOSITION, 0, 0);
			InsertMenu(hSysMenu, 6, MF_SEPARATOR | MF_BYPOSITION, 0, 0);

			hStatus = CreateStatusWindow(WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP, "", hWnd, NULL);
			SendMessage(hStatus, SB_SETMINHEIGHT, 30, 0);
			SendMessage(hStatus, WM_SIZE, 0, 0);
			GetWindowRect(hStatus, &rc);
			OffsetRect(&rc, -rc.left, -rc.top);
			status_h = rc.bottom;
			iRight[1] = rc.right - 200;
			iRight[2] = rc.right - 100;
			SendMessage(hStatus, SB_SETPARTS, 4, (LPARAM)iRight);

			SetRect(&rc, 0, 0, btnSize * 4 + 9 * 2 + 6, status_h);
			InflateRect(&rc, -3, -2);
			hStatic = CreateWindowEx(0, WC_STATIC, "", WS_CHILD | WS_VISIBLE,
			_RECT(rc), hStatus, NULL, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), NULL);
			SetWindowLong(hStatic, GWL_USERDATA, SetWindowLong(hStatic, GWL_WNDPROC, (LPARAM)stHookProc));

			hTool = CreateToolbarEx(hStatic, WS_CHILD | WS_VISIBLE, NULL, 6, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
			IDB_STD_SMALL_COLOR, tbtn, 6, 0, 0, 16, 16, sizeof(TBBUTTON));

			SendMessage(hTool, TB_ADDBITMAP, 6, (LPARAM)&tbmp);

			hToolTips = CreateWindowEx(0, TOOLTIPS_CLASS, "", TTS_ALWAYSTIP,
			0, 0, 0, 0, hWnd, NULL, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), NULL);

			ToolInfo.hwnd = hTool;
			ToolInfo.hinst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
			for (int i = 0; i < 4; i++){
				ToolInfo.uId = psh1 + i;
				ToolInfo.lpszText = menu[i].str;
				SendMessage(hTool, TB_GETITEMRECT, psh1 + i, (LPARAM)&ToolInfo.rect);
				SendMessage(hToolTips, TTM_ADDTOOL, 0, (LPARAM)&ToolInfo);
			}
			SendMessage(hTool, TB_SETTOOLTIPS, (WPARAM)hToolTips, 0);

			GetClientRect(hWnd, &rc);
			rc.bottom -= status_h;
			hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, RICHEDIT_CLASS, "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_READONLY | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL | WS_VSCROLL | WS_HSCROLL,
			_RECT(rc), hWnd, NULL, (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), NULL);
			SendMessage(hEdit, EM_SETLANGOPTIONS, 0, (LPARAM)((SendMessage(hEdit, EM_GETLANGOPTIONS, 0, 0) & ~IMF_DUALFONT) | IMF_UIFONTS));
			SendMessage(hEdit, EM_SETTABSTOPS, 1, (LPARAM)&iTab);

			hEditFont = CreateFontIndirect(&logfont);
			SendMessage(hEdit, WM_SETFONT, (WPARAM)hEditFont, 0);

			SetFocus(hEdit);
			break;
		case WM_SIZE:
			MoveWindow(hStatus, 0, HIWORD(lParam) - status_h, LOWORD(lParam), HIWORD(lParam), false);
			iRight[1] = LOWORD(lParam) - 200;
			iRight[2] = LOWORD(lParam) - 100;
			SendMessage(hStatus, SB_SETPARTS, 4, (LPARAM)iRight);
			MoveWindow(hEdit, 0, 0, LOWORD(lParam), HIWORD(lParam) - status_h, false);
			break;
		case WM_SYSCOMMAND:
			switch (LOWORD(wParam)){
				case psh1:
					strcpy_s(szFile, "");
					ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
					if (GetOpenFileName(&ofn)){
						strcpy_s(param[4], szFile);
						SendMessage(hEdit, WM_SETTEXT, 0, 0);
						SendMessage(hEdit, EM_EMPTYUNDOBUFFER, 0, 0);
						SendMessage(hStatus, SB_SETTEXT, 1, (LPARAM)param[4]);
						SendMessage(hStatus, SB_SETTEXT, 2, (LPARAM)"");
						SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)"");
						SetFocus(hEdit);
						main(5, argv);
						sprintf_s(szFile, "line = %d", SendMessage(hEdit, EM_GETLINECOUNT, 0, 0));
						SendMessage(hStatus, SB_SETTEXT, 2, (LPARAM)szFile);
						sprintf_s(szFile, "size = %d", SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0));
						SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)szFile);
					}
					break;
				case psh2:
					dwSize = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0);
					if (dwSize){
						strcpy_s(szFile, param[4]);
						ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
						if (GetSaveFileName(&ofn)){
							dwSize = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0);
							lpbuffer = (char *)calloc(dwSize + 1, 1);
							if (lpbuffer){
								SendMessage(hEdit, EM_EMPTYUNDOBUFFER, 0, 0);
								GetWindowText(hEdit, lpbuffer, dwSize + 1);
								if (!fopen_s(&fp, szFile, "wb")){
									fwrite(lpbuffer, dwSize, 1, fp);
									fclose(fp);
								}
								free(lpbuffer);
							}
						}
					}
					break;
				case psh3:
					sprintf_s(szFile, "notepad.exe \"%s\"", param[2]);
					if (CreateProcess(NULL, szFile, NULL, NULL, false, 0, NULL, NULL, &si, &pi)){
						WaitForInputIdle(pi.hProcess, WAIT_TIMEOUT * 4);
						EnumWindows(EnumWindowsProc, pi.dwThreadId);
						CloseHandle(pi.hThread);
						CloseHandle(pi.hProcess);
					}
					break;
				case psh4:
					mbp.hwndOwner = hWnd;
					mbp.hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
					MessageBoxIndirect(&mbp);
					break;
				default:
					return DefWindowProc(hWnd, uMsg, wParam, lParam);
			}
			break;
		case WM_CLOSE:
			DeleteObject(hEditFont);
			DestroyWindow(hWnd);
			return 1;
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}

	return 0;
}
//--------------------------------------------------------
//֐ WinMain
//--------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPSTR /*lpszCmdLine*/, int nCmdShow)
{
	InitCommonControls();
	HMODULE hRtLib;
	hRtLib = LoadLibrary("RichEd20.DLL");

	//CEChE쐬
	WNDCLASSEX myClass = {sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, WindProc, 0, 0, hInstance, 0, 0, (HBRUSH)(COLOR_BTNFACE + 1), 0, "Uncrustify"};
	myClass.hCursor = (HCURSOR)LoadImage(NULL, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	myClass.hIcon = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	myClass.hIconSm = (HICON)LoadImage(NULL, IDI_WINLOGO, IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);

	//EBhE NXo^
	RegisterClassEx(&myClass);

	//CEChE̐
	HWND hWnd = CreateWindowEx(WS_EX_CONTROLPARENT, "Uncrustify", "\[X`c[(Uncrustify,cppp)", WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	//EChE̕\(\@nCmdShowɏ])
	ShowWindow(hWnd, nCmdShow);

	//SetTimer(hWnd, WM_TIMER, 100, NULL);

	//Ă郁bZ[W|󂵂ăvV[Wɓn
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	FreeLibrary(hRtLib);

	return (msg.wParam);
}
